## marisa 0.3.1+git20250817

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)

file(STRINGS "VERSION" VERSION_STR)
project(Marisa VERSION "${VERSION_STR}" LANGUAGES C CXX)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/finders")

# Options
option(ENABLE_NATIVE_CODE "Enable -march=native and supported instructions" OFF)
option(ENABLE_TOOLS "Enables command-line tools" ON)
option(ENABLE_ASAN "Enable address sanitizer" OFF)
option(ENABLE_UBSAN "Enable undefined behavior sanitizer" OFF)
option(ENABLE_GPERFTOOLS_PROFILER "Find and link gperftools profiler" OFF)
option(ENABLE_COVERAGE "Enable code coverage instrumentation (only enabled with BUILD_TESTING)" OFF)
option(ENABLE_STATIC_STDLIB "Link C++ stdlib statically" OFF)

include(GNUInstallDirs)
set(LIB_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}" CACHE PATH "")

if(CMAKE_INSTALL_LIBDIR MATCHES "lib64$")
  set(LIB_SUFFIX 64)
endif()

function(check_macro_defined MACRO OUTPUT_VAR)
  set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)
  try_compile(result
    SOURCE_FROM_CONTENT
      "check_${OUTPUT_VAR}.cc"
      "#ifndef ${MACRO}\n#error \"${MACRO} is missing\"\n#endif\n"
    COMPILE_DEFINITIONS -march=native
  )
  set("${OUTPUT_VAR}" "${result}" PARENT_SCOPE)
  message("${OUTPUT_VAR}: ${result}")
endfunction()
if(ENABLE_NATIVE_CODE)
  check_macro_defined(__SSE2__ HAVE_SSE2)
  check_macro_defined(__SSE3__ HAVE_SSE3)
  check_macro_defined(__SSSE3__ HAVE_SSSE3)
  check_macro_defined(__SSE4_1__ HAVE_SSE4_1)
  check_macro_defined(__SSE4_2__ HAVE_SSE4_2)
  check_macro_defined(__POPCNT__ HAVE_POPCNT)
  check_macro_defined(__BMI__ HAVE_BMI)
  check_macro_defined(__BMI2__ HAVE_BMI2)
endif()

include(CMakeDependentOption)
cmake_dependent_option(ENABLE_SSE2 "Use SSE2 instructions" ON "ENABLE_NATIVE_CODE;HAVE_SSE2" OFF)
cmake_dependent_option(ENABLE_SSE3 "Use SSE3 instructions" ON "ENABLE_NATIVE_CODE;HAVE_SSE3" OFF)
cmake_dependent_option(ENABLE_SSSE3 "Use SSSE3 instructions" ON "ENABLE_NATIVE_CODE;HAVE_SSSE3" OFF)
cmake_dependent_option(ENABLE_SSE4_1 "Use SSE4_1 instructions" ON "ENABLE_NATIVE_CODE;HAVE_SSE4_1" OFF)
cmake_dependent_option(ENABLE_SSE4_2 "Use SSE4_2 instructions" ON "ENABLE_NATIVE_CODE;HAVE_SSE4_2" OFF)
cmake_dependent_option(ENABLE_POPCNT "Use POPCNT instructions" ON "ENABLE_NATIVE_CODE;HAVE_POPCNT" OFF)
cmake_dependent_option(ENABLE_BMI "Use BMI instructions" ON "ENABLE_NATIVE_CODE;HAVE_BMI" OFF)
cmake_dependent_option(ENABLE_BMI2 "Use BMI2 instructions" ON "ENABLE_NATIVE_CODE;HAVE_BMI2" OFF)
function(add_native_code TARGET)
  if(ENABLE_NATIVE_CODE)
    target_compile_options("${TARGET}" PRIVATE -march=native)
    if(ENABLE_BMI2)
      target_compile_options("${TARGET}" PRIVATE -DMARISA_USE_BMI2 -mbmi2 -msse4)
    elseif(ENABLE_BMI)
      target_compile_options("${TARGET}" PRIVATE -DMARISA_USE_BMI -mbmi -msse4)
    elseif(ENABLE_SSE4A)
      target_compile_options("${TARGET}" PRIVATE -DMARISA_USE_SSE4A -msse4a)
    elseif(ENABLE_SSE4_2 AND ENABLE_POPCNT)
      target_compile_options("${TARGET}" PRIVATE -DMARISA_USE_SSE4 -msse4)
    elseif(ENABLE_SSE4_2)
      target_compile_options("${TARGET}" PRIVATE -DMARISA_USE_SSE4_2 -msse4.2)
    elseif(ENABLE_SSE4_1)
      target_compile_options("${TARGET}" PRIVATE -DMARISA_USE_SSE4_1 -msse4.1)
    elseif(ENABLE_SSSE3)
      target_compile_options("${TARGET}" PRIVATE -DMARISA_USE_SSSE3 -mssse3)
    elseif(ENABLE_SSE3)
      target_compile_options("${TARGET}" PRIVATE -DMARISA_USE_SSE3 -msse3)
    elseif(ENABLE_SSE2)
      target_compile_options("${TARGET}" PRIVATE -DMARISA_USE_SSE2 -msse2)
    endif()
  endif()
endfunction()

include(CTest)

# We allow C++20 features if the compiler supports them
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED OFF)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON) # for clang-tidy

# Target Windows 8 for PrefetchVirtualMemory
if (MINGW)
    add_compile_definitions(_WIN32_WINNT=_WIN32_WINNT_WIN8)
endif()

# MSVC Configuration
# https://learn.microsoft.com/en-us/cpp/build/reference/utf-8-set-source-and-executable-character-sets-to-utf-8?view=msvc-170
# https://learn.microsoft.com/en-us/cpp/build/reference/zc-cplusplus?view=msvc-170
add_compile_options("$<$<COMPILE_LANG_AND_ID:C,MSVC>:/utf-8>")
add_compile_options("$<$<COMPILE_LANG_AND_ID:CXX,MSVC>:/utf-8;/Zc:__cplusplus>")

# Sanitizers support
function(add_sanitizers TARGET)
  if(NOT MSVC)
    if(ENABLE_ASAN)
      target_compile_options(${TARGET} PUBLIC -fsanitize=address)
      target_link_libraries(${TARGET} PUBLIC -fsanitize=address)
    endif()
    if(ENABLE_UBSAN)
      target_compile_options(${TARGET} PUBLIC -fsanitize=undefined)
      target_link_libraries(${TARGET} PUBLIC -fsanitize=undefined)
    endif()
  endif()
endfunction()

# gperftools support (https://github.com/gperftools/gperftools)
function(add_gperftools TARGET)
  if(ENABLE_GPERFTOOLS_PROFILER)
    if(NOT Gperftools_FOUND)
      find_package(Gperftools REQUIRED)
      set(ENABLE_STATIC_STDLIB OFF)
    endif()

    # Compile with information about file and line numbers for everything
    # even in non-Debug build types.
    if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
      target_compile_options(${TARGET} PRIVATE -g2)
    elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      # Use the more size-efficient `-gmlt` option on clang.
      target_compile_options(${TARGET} PRIVATE -gmlt)
    endif()
    target_link_libraries(${TARGET} PUBLIC ${GPERFTOOLS_LIBRARIES})
  endif()
endfunction()

# Applies configuration to the target based on options.
function(configure_target_from_options TARGET)
  add_sanitizers(${TARGET})
  add_gperftools(${TARGET})
  target_compile_definitions(${TARGET} PRIVATE $<$<CONFIG:DEBUG>:_DEBUG>)
  if(MARISA_ENABLE_STATIC_STDLIB)
    if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
      target_link_libraries(marisa PUBLIC -static-libgcc -static-libstdc++)
    endif()
  endif()
endfunction()

# Marisa Library
set(MARISA_HEADERS
  include/marisa.h
  include/marisa/agent.h
  include/marisa/base.h
  include/marisa/iostream.h
  include/marisa/key.h
  include/marisa/keyset.h
  include/marisa/query.h
  include/marisa/stdio.h
  include/marisa/trie.h
)
add_library(marisa
  ${MARISA_HEADERS}
  lib/marisa/agent.cc
  lib/marisa/grimoire/algorithm/sort.h
  lib/marisa/grimoire/intrin.h
  lib/marisa/grimoire/io.h
  lib/marisa/grimoire/io/mapper.cc
  lib/marisa/grimoire/io/mapper.h
  lib/marisa/grimoire/io/reader.cc
  lib/marisa/grimoire/io/reader.h
  lib/marisa/grimoire/io/writer.cc
  lib/marisa/grimoire/io/writer.h
  lib/marisa/grimoire/trie.h
  lib/marisa/grimoire/trie/cache.h
  lib/marisa/grimoire/trie/config.h
  lib/marisa/grimoire/trie/entry.h
  lib/marisa/grimoire/trie/header.h
  lib/marisa/grimoire/trie/history.h
  lib/marisa/grimoire/trie/key.h
  lib/marisa/grimoire/trie/louds-trie.cc
  lib/marisa/grimoire/trie/louds-trie.h
  lib/marisa/grimoire/trie/range.h
  lib/marisa/grimoire/trie/state.h
  lib/marisa/grimoire/trie/tail.cc
  lib/marisa/grimoire/trie/tail.h
  lib/marisa/grimoire/vector.h
  lib/marisa/grimoire/vector/bit-vector.cc
  lib/marisa/grimoire/vector/bit-vector.h
  lib/marisa/grimoire/vector/flat-vector.h
  lib/marisa/grimoire/vector/pop-count.h
  lib/marisa/grimoire/vector/rank-index.h
  lib/marisa/grimoire/vector/vector.h
  lib/marisa/keyset.cc
  lib/marisa/trie.cc
)
target_include_directories(marisa
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
  PRIVATE
    lib
)
set_target_properties(marisa PROPERTIES
  VERSION "${Marisa_VERSION}"
  SOVERSION "${Marisa_VERSION_MAJOR}"
)
configure_target_from_options(marisa)
add_native_code(marisa)
add_library(Marisa::marisa ALIAS marisa)

# Tools
set(MARISA_TOOLS
  marisa-build
  marisa-lookup
  marisa-reverse-lookup
  marisa-common-prefix-search
  marisa-predictive-search
  marisa-dump
  marisa-benchmark
)
if(ENABLE_TOOLS)
  add_library(cmdopt STATIC tools/cmdopt.h tools/cmdopt.cc)
  target_include_directories(cmdopt PUBLIC tools)

  foreach(_tool ${MARISA_TOOLS})
    add_executable(${_tool} "tools/${_tool}.cc")
    target_link_libraries(${_tool} PRIVATE marisa cmdopt)
    configure_target_from_options(${_tool})
  endforeach()
endif()

# Testing
if(BUILD_TESTING)
  foreach(_test
    base-test
    io-test
    vector-test
    trie-test
    marisa-test
  )
    add_executable(${_test} "tests/${_test}.cc")
    target_link_libraries(${_test} PRIVATE marisa)
    target_include_directories(${_test} PRIVATE tests lib)
    configure_target_from_options(${_test})
    add_native_code(${_test})
    add_test(
      NAME ${_test}
      COMMAND ${_test}
    )
  endforeach()

  if(ENABLE_COVERAGE)
    if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
      message(WARNING "Code coverage is not supported with MSVC")
    else()
      target_compile_options(marisa PUBLIC --coverage)
      target_link_options(marisa PUBLIC --coverage)
    endif()
  endif()
endif()

# Install configuration

if(NOT DEFINED LIB_INSTALL_DIR)
  set(LIB_INSTALL_DIR lib)
endif()

# We do not pass PUBLIC_HEADER because it doesn't respect subdirectories.
# Instead, we install the headers manually via a second call to `install`.
install(
  TARGETS marisa
  EXPORT MarisaTargets
  CONFIGURATIONS Release
  DESTINATION ${LIB_INSTALL_DIR}
  COMPONENT Library
)
install(
  DIRECTORY include/
  DESTINATION include
  COMPONENT Library
  FILES_MATCHING PATTERN "*.h"
)

if(ENABLE_TOOLS)
  install(
    TARGETS ${MARISA_TOOLS}
    CONFIGURATIONS Release
    COMPONENT Binaries
  )
endif()

set(ConfigPackageLocation "${LIB_INSTALL_DIR}/cmake/Marisa")

include(CMakePackageConfigHelpers)
configure_package_config_file(Marisa.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/Marisa/MarisaConfig.cmake"
  INSTALL_DESTINATION ${ConfigPackageLocation}
)
write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/Marisa/MarisaConfigVersion.cmake"
  VERSION ${Marisa_VERSION}
  COMPATIBILITY SameMajorVersion
)

export(EXPORT MarisaTargets
  FILE "${CMAKE_CURRENT_BINARY_DIR}/Marisa/MarisaTargets.cmake"
  NAMESPACE Marisa::
)

install(EXPORT MarisaTargets
  FILE MarisaTargets.cmake
  NAMESPACE Marisa::
  DESTINATION ${ConfigPackageLocation}
  COMPONENT Library
)

install(
  FILES
    "${CMAKE_CURRENT_BINARY_DIR}/Marisa/MarisaConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/Marisa/MarisaConfigVersion.cmake"
  DESTINATION
    ${ConfigPackageLocation}
  COMPONENT Library
)

configure_file(marisa.pc.in ${CMAKE_CURRENT_BINARY_DIR}/marisa.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/marisa.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)

=== bindings/Makefile ===
ALL: swig-perl swig-python3 swig-ruby

swig-perl:
	swig -Wall -c++ -perl -outdir perl marisa-swig.i
	mv marisa-swig_wrap.cxx perl
	cp marisa-swig.cxx marisa-swig.h perl

swig-python:
	swig -Wall -c++ -python -outdir python marisa-swig.i
	mv marisa-swig_wrap.cxx python
	cp marisa-swig.cxx marisa-swig.h python

swig-python3:
	swig -Wall -c++ -python -outdir python3 marisa-swig-python3.i
	mv marisa-swig-python3_wrap.cxx python3
	cp marisa-swig-python3.cxx marisa-swig-python3.h python3

swig-ruby:
	swig -Wall -c++ -ruby -outdir ruby marisa-swig.i
	mv marisa-swig_wrap.cxx ruby
	cp marisa-swig.cxx marisa-swig.h ruby

## marisa 0.2.4

=== debian/changelog ===
marisa (0.2.4-8build6) xenial; urgency=medium

  * No-change rebuild for ruby2.3-only support.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 13 Mar 2016 21:14:59 +0000

marisa (0.2.4-8build5) xenial; urgency=medium

  * No-change rebuild to drop python3.4 support.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 18 Jan 2016 19:39:19 +0000

marisa (0.2.4-8build4) xenial; urgency=medium

  * Rebuild for Perl 5.22.1.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 18 Dec 2015 10:39:59 +0000

marisa (0.2.4-8build3) wily; urgency=medium

  * No-change rebuild to add ruby2.2 support.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 08 Sep 2015 14:50:11 +0000

marisa (0.2.4-8build2) wily; urgency=medium

  * No-change rebuild using GCC 5.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Aug 2015 10:54:35 +0000

marisa (0.2.4-8build1) wily; urgency=medium

  * No-change rebuild for python3.5 transition

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 22 Jul 2015 19:00:55 +0000

marisa (0.2.4-8) unstable; urgency=medium

  [debian/control]
  * add ruby as a new dependency for ruby-marisa (Closes: #759527)
    Thanks to Lucas Kanashiro for the report.
  * set Maintainer as pkg-ime and add Uploaders me
  * split multi lines Depends and Build-Depends

  [debian/copyright]
  * fix invalid copyright information

  [debian/patches/support-mips64el.patch]
  * fix ftbfs on mips64el (Closes: #762001)
    Thanks to YunQiang Su for the report.

 -- Mitsuya Shibata <mty.shibata@gmail.com>  Thu, 18 Sep 2014 01:16:29 +0900

marisa (0.2.4-7) unstable; urgency=medium

  * Fix missing link for libmarisa-perl
  * Fix FTBFS on s390x/sparc64 (Closes: #739126, #755560)
    Thanks to Aurelien Jarno and Guo Yixuan for the report.
  * Support DEP8/autopkgtest

 -- Mitsuya Shibata <mty.shibata@gmail.com>  Thu, 31 Jul 2014 02:32:22 +0900

marisa (0.2.4-6) unstable; urgency=medium

  * support building with Ruby 2.0/2.1 (Closes:  #743989)
    Thanks to Christian Hofstaedtler for the report.

 -- Mitsuya Shibata <mty.shibata@gmail.com>  Sun, 13 Apr 2014 23:27:56 +0900

marisa (0.2.4-5) unstable; urgency=medium

  * Use dh-autoreconf instead of autotools-dev to fix FTBFS on ppc64el.
    Thanks to Logan Rosen for the report. (Closes: #736696)

 -- Mitsuya Shibata <mty.shibata@gmail.com>  Sun, 26 Jan 2014 15:13:59 +0900

marisa (0.2.4-4) unstable; urgency=low

  * Initial upload to Debian archive (Closes: #714453)
  * Added Vcs-Browser and Vcs-Git fields
  * Bump standards version to 3.9.5

 -- Mitsuya Shibata <mty.shibata@gmail.com>  Thu, 21 Nov 2013 22:03:51 +0900

marisa (0.2.4-3) unstable; urgency=low

  * Updated patch for DEP3.
  * Auto generate version for python/setup.py.
  * Fixed install path for ruby bindings.
  * Exec extconf.rb after building libmarisa.

 -- Mitsuya Shibata <mty.shibata@gmail.com>  Sun, 17 Nov 2013 18:56:22 +0900

marisa (0.2.4-2) unstable; urgency=low

  * Fixed problems pointed out by sponsor.
    - Removed full stops from short descriptions.
    - Renamed perl package name as per Perl Policy §4.2.
    - Changed path of perl modules.
    - Refined compile options.
    - Fixed dpkg-gencontrol warnings.
    - Added manpages.
  * module-version-for-egg-inof.patch
    - For lintian4py warning, python module version in setup.py is specified.

 -- Mitsuya Shibata <mty.shibata@gmail.com>  Wed, 14 Aug 2013 19:29:20 +0900

marisa (0.2.4-1) unstable; urgency=low

  * Initial release (Closes: #714453)

 -- Mitsuya Shibata <mty.shibata@gmail.com>  Sat, 29 Jun 2013 10:53:00 +0900

=== debian/control ===
Source: marisa
Section: libs
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Mitsuya Shibata <mty.shibata@gmail.com>
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               perl,
               python-all-dev (>= 2.6.6-3),
               python3-all-dev (>= 3.1.3-12),
               ruby,
               ruby-dev,
               swig
Standards-Version: 3.9.5
Homepage: https://code.google.com/p/marisa-trie/
Vcs-Browser: https://github.com/m-shibata/marisa-dpkg
Vcs-Git: git://github.com/m-shibata/marisa-dpkg.git
XS-Testsuite: autopkgtest

Package: marisa
Section: utils
Architecture: any
Depends: libmarisa0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: commmand line tools for libmarisa
 Matching Algorithm with Recursively Implemented StorAge (MARISA) is a static
 and space-efficient trie data structure.
 .
 This package conteins commmand line tools for libmarisa.

Package: libmarisa0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ library to provide an implementation of MARISA
 Matching Algorithm with Recursively Implemented StorAge (MARISA) is a static
 and space-efficient trie data structure.
 .
 This package contains C++ library to provide an implementation of MARISA.

Package: libmarisa-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmarisa0 (= ${binary:Version}), ${misc:Depends}
Description: developement files for libmarisa
 Matching Algorithm with Recursively Implemented StorAge (MARISA) is a static
 and space-efficient trie data structure.
 .
 This package contains the files necessary for compiling programs that
 depend on MARISA.

Package: python-marisa
Section: python
Architecture: any
Provides: ${python:Provides}
Depends: libmarisa0 (= ${binary:Version}),
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Description: Python bindings for MARISA
 Matching Algorithm with Recursively Implemented StorAge (MARISA) is a static
 and space-efficient trie data structure.
 .
 This package contains Python bindings for MARISA.

Package: python3-marisa
Section: python
Architecture: any
Depends: libmarisa0 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Python3 bindings for MARISA
 Matching Algorithm with Recursively Implemented StorAge (MARISA) is a static
 and space-efficient trie data structure.
 .
 This package contains Python 3 bindings for MARISA.

Package: libmarisa-perl
Section: perl
Architecture: any
Multi-Arch: foreign
Depends: libmarisa0 (= ${binary:Version}),
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Description: Perl bindings for MARISA
 Matching Algorithm with Recursively Implemented StorAge (MARISA) is a static
 and space-efficient trie data structure.
 .
 This package contains Perl bindings for MARISA.

Package: ruby-marisa
Section: ruby
Architecture: any
Multi-Arch: foreign
Depends: libmarisa0 (= ${binary:Version}),
         ruby,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Ruby bindings for MARISA
 Matching Algorithm with Recursively Implemented StorAge (MARISA) is a static
 and space-efficient trie data structure.
 .
 This package contains Ruby bindings for MARISA.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# These commands build the list of supported Python 3 versions
# The last version should be just “python3” so that the scripts
# get a correct shebang.
# Use just “PYTHON3 := $(shell py3versions -r)” if your package
# doesn’t contain scripts
PY3REQUESTED := $(shell py3versions -r)
PY3DEFAULT := $(shell py3versions -d)
PYTHON3 := $(filter-out $(PY3DEFAULT),$(PY3REQUESTED)) python3

# For set install path of perl modules.
PERL_VENDOR_ARCH=$(shell perl -V:vendorarch|cut -d\' -f2)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

PKG_VERSION = $(shell dpkg-parsechangelog | grep ^Version: | cut -d' ' -f2 | cut -f 1 -d -)

%:
	dh $@  --with autoreconf --with python2,python3

override_dh_auto_configure:
	dh_auto_configure
	make -C bindings
	cd bindings/python; sed -i "s/__version__/$(PKG_VERSION)/" setup.py
	cd bindings/perl; perl Makefile.PL \
	    INSTALL_BASE=$(CURDIR)/debian/libmarisa-perl/usr \
	    INSTALLARCHLIB=$(CURDIR)/debian/libmarisa-perl$(PERL_VENDOR_ARCH) \
	    INSTALLSITEARCH=$(CURDIR)/debian/libmarisa-perl$(PERL_VENDOR_ARCH) \
	    INSTALLVENDORARCH=$(CURDIR)/debian/libmarisa-perl$(PERL_VENDOR_ARCH) \
	    INC="-I../../lib" \
	    LIBS="-L../../lib/.libs" \
	    CCFLAGS="$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)" \
	    LDDLFLAGS="-shared -L/usr/local/lib -L../../lib/.libs -lmarisa -fstack-protector $(shell dpkg-buildflags --get LDFLAGS)"

override_dh_auto_build:
	dh_auto_build
	# Build for each Python 3 version
	cd bindings/python; \
	    set -ex; for python in $(PYTHON3); do \
	    $$python setup.py build_ext --include-dirs=../../lib \
	        --library-dirs=../../lib/.libs; \
	    done
	cd bindings/python; \
	    python2 setup.py build_ext --include-dirs=../../lib \
	        --library-dirs=../../lib/.libs
	cd bindings/perl; make
	# extconf.rb needs to exist library when configure
	cd bindings/ruby; ruby extconf.rb --with-opt-include=../../lib \
	    --with-opt-lib=../../lib/.libs
	# set verbose option for compiling
	sed -i 's/^V = 0/V = 1/' bindings/ruby/Makefile
	sed -i 's%^sitearchdir = .*%sitearchdir = $$(exec_prefix)/lib/$(DEB_HOST_MULTIARCH)/ruby/$$(ruby_version)%' bindings/ruby/Makefile
	cd bindings/ruby; make

override_dh_auto_install:
	dh_auto_install
	# The same for install; note the --install-layout=deb option
	cd bindings/python; \
	    set -ex; for python in $(PYTHON3); do \
	    $$python setup.py install \
	        --root=$(CURDIR)/debian/python3-marisa --install-layout=deb; \
	    done
	cd bindings/python; \
	    python2 setup.py install \
	        --root=$(CURDIR)/debian/python-marisa --install-layout=deb
	# install perl modules
	cd bindings/perl; make install
	rm $(CURDIR)/debian/libmarisa-perl$(PERL_VENDOR_ARCH)/auto/marisa/.packlist
	rm $(CURDIR)/debian/libmarisa-perl$(PERL_VENDOR_ARCH)/perllocal.pod
	rm $(CURDIR)/debian/libmarisa-perl$(PERL_VENDOR_ARCH)/sample.pl
	# install ruby modules
	cd bindings/ruby; make install DESTDIR=$(CURDIR)/debian/ruby-marisa

=== debian/tests/control ===
Tests: python3
Depends: python3-marisa

Tests: python2
Depends: python-marisa

Tests: perl
Depends: libmarisa-perl

Tests: ruby
Depends: ruby-marisa

Tests: build
Depends: libmarisa-dev, pkg-config, build-essential

Tests: tools
Depends: marisa

=== debian/watch ===
version=3
http://code.google.com/p/marisa-trie/downloads/list?can=1 .*/marisa-(\d[\d.]*)\.(?:zip|tgz|tbz2|txz|tar\.gz|tar\.bz2|tar\.xz)

## marisa 0.2.5

=== debian/changelog ===
marisa (0.2.5-6build2) focal; urgency=medium

  [ Rafael David Tinoco ]
  * Sponsoring ruby2.7 transitions

  [ Lucas Kanashiro ]
  * No-change rebuild for ruby2.7

 -- Rafael David Tinoco <rafaeldtinoco@ubuntu.com>  Mon, 02 Mar 2020 16:35:26 +0000

marisa (0.2.5-6build1) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 10:20:50 +0100

marisa (0.2.5-6) unstable; urgency=high

  * debian/tests/: Drop python2-related autopkgtest as well.

 -- Boyuan Yang <byang@debian.org>  Mon, 23 Dec 2019 12:23:38 -0500

marisa (0.2.5-5) unstable; urgency=medium

  * Drop python2 package. (Closes: #936993)
  * debian/rules: Use chrpath to delete all RPATH inside shared
    library files.

 -- Boyuan Yang <byang@debian.org>  Sun, 22 Dec 2019 21:42:20 -0500

marisa (0.2.5-4) unstable; urgency=medium

  * debian/control:
    + Bump Standards-Version to 4.4.1.
  * debian/rules: Fix build around perl and gcc-9. Patch provided
    by Niko Tyni. (Closes: #942073)
  * Recover usage of dh_dwz again since the issue has been solved.

 -- Boyuan Yang <byang@debian.org>  Tue, 15 Oct 2019 09:46:57 -0400

marisa (0.2.5-3) unstable; urgency=medium

  * debian/control:
    + Bump Standards-Version to 4.4.0.
    + Bump debhelper compat to v12.
  * debian/copyright: Fix incorrect license name. (Closes: #920663)
  * debian/patches: Backport upstream patches till 20181102.
  * debian/rules: Temporarily stop calling dh_dwz when building.

 -- Boyuan Yang <byang@debian.org>  Wed, 10 Jul 2019 11:46:44 -0400

marisa (0.2.5-2) unstable; urgency=medium

  * Rebuild against gcc 8.
  * debian/control:
    + Update my uploader email address and use the @debian.org one.
    + Bump Standards-Version to 4.2.1 (no changes needed).
    + Remove deprecated X-Python3-Version field.
    + Update Vcs-* fields and use the repo under input-method-team group.
  * debian/rules: Use architecture.mk to provide DEB_HOST_MULTIARCH var.

 -- Boyuan Yang <byang@debian.org>  Wed, 12 Sep 2018 16:02:52 -0400

marisa (0.2.5-1) unstable; urgency=medium

  [ Mitsuya Shibata ]
  * add dh-python to Build-Depends
  * remove no longer needed XS-Testsuite field
  * fix typo

  [ Boyuan Yang ]
  * New upstream release with different upstream on GitHub.
    Closes: #900680.
  * debian: Apply "wrap-and-sort -abst" for unified format.
  * debian/control:
    - Add myself into uploaders list.
    - Bump Standards-Version to 4.1.4.
    - Add X-Python3-Version field as recommended.
    - Replace "Extra" package priority with "Optional" to fit policy
      requirement.
    - Use debian-input-method@lists.debian.org in maintainer field.
      Closes: #899868.
    - Fix typo in package description. Closes: #808276.
  * debian/copyright:
    - Refresh upstream copyright information.
    - Add information about my contribution to debian/ dir.
    - Use GitHub repository for upstream source field.
  * debian/watch:
    - Rewrite in v4 format.
    - Use GitHub s-yata/marisa-trie as upstream.
  * debian/rules:
    - Use "dh_missing --fail-missing".
    - Avoid manual invocation of dpkg-parsechangelog.
    - Enable full hardening.
    - Explicitly remove .la files with file installation.
  * debian/docs: Refresh file list.
  * debian/doc-base: Register HTML document for libmarisa-dev.
  * debian/shlibs: Add a libmarisa0.shlibs file to restrict lib
    dependency (>= 0.2.5).
  * debian/patches: Refresh patches.
    - Fix Alpha wordsize detection. Closes: #836374.
    - Add support for riscv64 wordsize detection. Closes: #898018.
    - Backport various commits from upstream trunk.

 -- Boyuan Yang <073plan@gmail.com>  Tue, 05 Jun 2018 15:45:30 +0800

=== debian/control ===
Source: marisa
Section: libs
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
 Mitsuya Shibata <mty.shibata@gmail.com>,
Build-Depends:
 chrpath,
 debhelper-compat (= 12),
 dh-python,
 perl,
 python3-all-dev,
 ruby,
 ruby-dev,
 swig,
Standards-Version: 4.4.1
Rules-Requires-Root: no
Homepage: https://github.com/s-yata/marisa-trie
Vcs-Browser: https://salsa.debian.org/input-method-team/marisa
Vcs-Git: https://salsa.debian.org/input-method-team/marisa.git

Package: libmarisa-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libmarisa0 (= ${binary:Version}),
 ${misc:Depends},
Description: development files for libmarisa
 Matching Algorithm with Recursively Implemented StorAge (MARISA) is a static
 and space-efficient trie data structure.
 .
 This package contains the files necessary for compiling programs that
 depend on MARISA.

Package: libmarisa-perl
Section: perl
Architecture: any
Multi-Arch: foreign
Depends:
 libmarisa0 (= ${binary:Version}),
 ${misc:Depends},
 ${perl:Depends},
 ${shlibs:Depends},
Description: Perl bindings for MARISA
 Matching Algorithm with Recursively Implemented StorAge (MARISA) is a static
 and space-efficient trie data structure.
 .
 This package contains Perl bindings for MARISA.

Package: libmarisa0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: C++ library to provide an implementation of MARISA
 Matching Algorithm with Recursively Implemented StorAge (MARISA) is a static
 and space-efficient trie data structure.
 .
 This package contains C++ library to provide an implementation of MARISA.

Package: marisa
Section: utils
Architecture: any
Depends:
 libmarisa0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: command line tools for libmarisa
 Matching Algorithm with Recursively Implemented StorAge (MARISA) is a static
 and space-efficient trie data structure.
 .
 This package contains command line tools for libmarisa.

Package: python3-marisa
Section: python
Architecture: any
Depends:
 libmarisa0 (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python3 bindings for MARISA
 Matching Algorithm with Recursively Implemented StorAge (MARISA) is a static
 and space-efficient trie data structure.
 .
 This package contains Python 3 bindings for MARISA.

Package: ruby-marisa
Section: ruby
Architecture: any
Multi-Arch: foreign
Depends:
 libmarisa0 (= ${binary:Version}),
 ruby,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Ruby bindings for MARISA
 Matching Algorithm with Recursively Implemented StorAge (MARISA) is a static
 and space-efficient trie data structure.
 .
 This package contains Ruby bindings for MARISA.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Retrieve package version information
include /usr/share/dpkg/pkg-info.mk

# Retrieve variables like DEB_HOST_MULTIARCH
include /usr/share/dpkg/architecture.mk

# These commands build the list of supported Python 3 versions
# The last version should be just “python3” so that the scripts
# get a correct shebang.
# Use just “PYTHON3 := $(shell py3versions -r)” if your package
# doesn’t contain scripts
PY3REQUESTED := $(shell py3versions -r)
PY3DEFAULT := $(shell py3versions -d)
PYTHON3 := $(filter-out $(PY3DEFAULT),$(PY3REQUESTED)) python3

# For set install path of perl modules.
PERL_VENDOR_ARCH=$(shell perl -V:vendorarch|cut -d\' -f2)


%:
	dh $@  --with python3

override_dh_auto_configure:
	dh_auto_configure
	make -C bindings
	cd bindings/python; sed -i "s/__version__/$(DEB_VERSION_UPSTREAM)/" setup.py

override_dh_auto_build:
	dh_auto_build
	cd bindings/perl; perl Makefile.PL \
	    INSTALL_BASE=$(CURDIR)/debian/libmarisa-perl/usr \
	    INSTALLARCHLIB=$(CURDIR)/debian/libmarisa-perl$(PERL_VENDOR_ARCH) \
	    INSTALLSITEARCH=$(CURDIR)/debian/libmarisa-perl$(PERL_VENDOR_ARCH) \
	    INSTALLVENDORARCH=$(CURDIR)/debian/libmarisa-perl$(PERL_VENDOR_ARCH) \
	    INC="-I../../include" \
	    LIBS="-L../../lib/marisa/.libs -lmarisa" \
	    CCFLAGS="$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)" \
	    LDDLFLAGS="-shared -L/usr/local/lib -fstack-protector $(shell dpkg-buildflags --get LDFLAGS)"
	# Build for each Python 3 version
	cd bindings/python; \
	    set -ex; for python in $(PYTHON3); do \
	    $$python setup.py build_ext --include-dirs=../../include \
	        --library-dirs=../../lib/marisa/.libs; \
	    done
	cd bindings/perl; make
	# extconf.rb needs to exist library when configure
	cd bindings/ruby; ruby extconf.rb --with-opt-include=../../include \
	    --with-opt-lib=../../lib/marisa/.libs
	# set verbose option for compiling
	sed -i 's/^V = 0/V = 1/' bindings/ruby/Makefile
	sed -i 's%^sitearchdir = .*%sitearchdir = $$(exec_prefix)/lib/$(DEB_HOST_MULTIARCH)/ruby/$$(ruby_version)%' bindings/ruby/Makefile
	cd bindings/ruby; make

override_dh_auto_install:
	dh_auto_install
	# Remove .la files
	rm debian/tmp/usr/lib/*/libmarisa.la
	# The same for install; note the --install-layout=deb option
	cd bindings/python; \
	    set -ex; for python in $(PYTHON3); do \
	    $$python setup.py install \
	        --root=$(CURDIR)/debian/python3-marisa --install-layout=deb; \
	    done
	# install perl modules
	# remove RPATH in perl-related so file
	( cd bindings/perl; find . -name "*.so*" -type f -exec chrpath --delete {} \; )
	( cd bindings/perl ; make install )
	rm $(CURDIR)/debian/libmarisa-perl$(PERL_VENDOR_ARCH)/auto/marisa/.packlist
	rm $(CURDIR)/debian/libmarisa-perl$(PERL_VENDOR_ARCH)/perllocal.pod
	rm $(CURDIR)/debian/libmarisa-perl$(PERL_VENDOR_ARCH)/sample.pl
	# install ruby modules
	cd bindings/ruby; make install DESTDIR=$(CURDIR)/debian/ruby-marisa

override_dh_missing:
	dh_missing --fail-missing

## marisa 0.2.6

=== debian/changelog ===
marisa (0.2.6-9build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 17 Mar 2022 19:28:46 +0000

marisa (0.2.6-9) unstable; urgency=high

  * debian/control: Restrict ruby version requirement to build-time
    ruby version using custom "ruby (>= ${ruby:Build-Version})" substvar
    to circumvent regression during ruby3.0-default transition.
    (Closes: #1006289)
  * debian/libmarisa0.symbols: Drop some disappeared optional symbols.

 -- Boyuan Yang <byang@debian.org>  Wed, 23 Feb 2022 02:35:04 -0500

marisa (0.2.6-8) unstable; urgency=medium

  * Team upload
  * debian/libmarisa0.symbols:
    - Added some "optional" to make it build without changes on
      Ubuntu's ppc64el.

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Fri, 17 Dec 2021 17:59:13 +0100

marisa (0.2.6-7) unstable; urgency=high

  * Reconfirm symbols using pkgkde-symbolshelper.
    (Closes: #997420)

 -- Boyuan Yang <byang@debian.org>  Sun, 24 Oct 2021 14:23:12 -0400

marisa (0.2.6-5) unstable; urgency=medium

  * Bump Standards-Version to 4.6.0.
  * Rebuild against GCC 11.
  * Refresh symbols with GCC 11 build again.
  * debian/control: Use dh-sequence-python3 as build-dependency.

 -- Boyuan Yang <byang@debian.org>  Sat, 23 Oct 2021 19:55:51 -0400

marisa (0.2.6-4) unstable; urgency=medium

  * Team upload
  * debian/libmarisa0.symbols:
    - Here we go again.. (for kfreebsd-amd64)

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Wed, 18 Aug 2021 18:30:30 +0200

marisa (0.2.6-3) unstable; urgency=medium

  * Team upload
  * Symbols file refreshed again, this time for alpha (closes: #981488)

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Sun, 15 Aug 2021 12:33:09 +0200

marisa (0.2.6-3~exp4) experimental; urgency=medium

  * Team upload
  * d/p/0004-Fix-wordsize-detection-for-x32-architecture.patch:
    - Tweaked the code a bit in a new attempt
  * Symbols file refreshing again, this time for ia64

 -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Wed, 10 Feb 2021 02:58:09 +0100

marisa (0.2.6-3~exp3) experimental; urgency=medium

  * Team upload
  * d/p/0004-Fix-wordsize-detection-for-x32-architecture.patch:
    - Attempt to fix FTBFS on x32 due to failed base-test
  * Further refresh of symbols file

 -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Mon, 08 Feb 2021 17:00:33 +0100

marisa (0.2.6-3~exp2) experimental; urgency=medium

  * Team upload
  * debian/libmarisa0.symbols, debian/control, debian/rules:
    - Use pkg-kde-tools to manage symbols file
  * Partial refresh of symbols file using buildd logs
    - It has not been built on some archs yet, but this upload makes it
      easier to proceed on the Ubuntu side (related to bug #981488).

 -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Wed, 03 Feb 2021 13:41:40 +0100

marisa (0.2.6-3~exp1) experimental; urgency=medium

  * Team upload
  * Replace shlibs file with symbols file
    - This is the first step in fixing bug #981488. However, this
      version of the symbols file was created on amd64, and the upload
      will probably fail to build on most architectures. A refreshed
      symbols file will be needed to complete the measure.
  * Bump Standards-Version to 4.5.1

 -- Gunnar Hjalmarsson <gunnarhj@ubuntu.com>  Mon, 01 Feb 2021 09:22:38 +0100

marisa (0.2.6-2) unstable; urgency=medium

  [ Steve Langasek ]
  * Make autopkgtests cross-test-friendly.

  [ Boyuan Yang ]
  * Rebuild with python3.9 only setup.
  * Bump Standards-Version to 4.5.1.

 -- Boyuan Yang <byang@debian.org>  Tue, 08 Dec 2020 11:55:00 -0500

marisa (0.2.6-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version to 4.5.0.
    + Bump debhelper compat to v13.
  * debian/shlibs: Bump version accordingly.

 -- Boyuan Yang <byang@debian.org>  Tue, 30 Jun 2020 09:56:03 -0400

=== debian/control ===
--- 
+++ 
@@ -7,14 +7,15 @@
  Mitsuya Shibata <mty.shibata@gmail.com>,
 Build-Depends:
  chrpath,
- debhelper-compat (= 12),
- dh-python,
+ debhelper-compat (= 13),
+ dh-sequence-python3,
  perl,
+ pkg-kde-tools,
  python3-all-dev,
  ruby,
  ruby-dev,
  swig,
-Standards-Version: 4.4.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/s-yata/marisa-trie
 Vcs-Browser: https://salsa.debian.org/input-method-team/marisa
@@ -94,7 +95,7 @@
 Multi-Arch: foreign
 Depends:
  libmarisa0 (= ${binary:Version}),
- ruby,
+ ruby (>= ${ruby:Build-Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Description: Ruby bindings for MARISA

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 # see FEATURE AREAS in dpkg-buildflags(1)
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+export DEB_LDFLAGS_MAINT_APPEND =
 
 # Retrieve package version information
 include /usr/share/dpkg/pkg-info.mk
@@ -27,7 +27,7 @@
 
 
 %:
-	dh $@  --with python3
+	dh $@  --with pkgkde_symbolshelper
 
 override_dh_auto_configure:
 	dh_auto_configure
@@ -80,5 +80,8 @@
 	# install ruby modules
 	cd bindings/ruby; make install DESTDIR=$(CURDIR)/debian/ruby-marisa
 
-override_dh_missing:
-	dh_missing --fail-missing
+# record minimum ruby version requirement
+# see https://bugs.debian.org/1006289
+override_dh_gencontrol:
+	dh_gencontrol -- \
+	        -V"ruby:Build-Version=$$(dpkg-query -f='$${Version}' -W ruby)"

## marisa 0.2.6.1

=== debian/changelog ===
marisa (0.2.6.1-1+deepin17+rb1) unstable; urgency=medium

  * No source change upload to avoid downgrade.

 -- Tianyu Chen <sweetyfish@deepin.org>  Fri, 12 Apr 2024 15:17:12 +0800

marisa (0.2.6-17) unstable; urgency=medium

  * Really fix #1065467.

 -- Boyuan Yang <byang@debian.org>  Tue, 12 Mar 2024 10:46:31 -0400

marisa (0.2.6-16) unstable; urgency=medium

  * debian/patches/0005-Add-wordsize-detection-for-LoongArch64.patch:
    Add proposed patch to fix FTBFS on LoongArch64. (Closes: #1065467)

 -- Boyuan Yang <byang@debian.org>  Mon, 11 Mar 2024 20:18:03 -0400

marisa (0.2.6-15) unstable; urgency=medium

  [ Matthias Klose ]
  * debian/tests/python3: Run the python3 autopkg test in $AUTOPKGTEST_TMP.
    This fixes the autopkgtest regression with python3.12.
    (Closes: #1061809)

 -- Boyuan Yang <byang@debian.org>  Mon, 12 Feb 2024 19:01:55 -0500

marisa (0.2.6-14) unstable; urgency=medium

  * Team upload

  [ Janitor ]
  * Set upstream metadata fields:
    - Bug-Database, Bug-Submit, Repository-Browse.
  * Set upstream metadata fields: Repository.

  [ Gunnar Hjalmarsson ]
  * Allow one to build twice (closes: #1047554, #1049679)

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Thu, 17 Aug 2023 16:20:59 +0200

marisa (0.2.6-13) unstable; urgency=medium

  * Drop version requirement on ruby since ruby3.1 transition in
    Debian has concluded. (LP: #1999550)
  * debian/control: Bump Standards-Version to 4.6.2.

 -- Boyuan Yang <byang@debian.org>  Fri, 27 Jan 2023 20:19:12 -0500

marisa (0.2.6-12) unstable; urgency=high

  * Force rebuild against ruby3.1 to avoid unreasonable autopkgtest
    regression. (Closes: #1025889)
  * debian/source/lintian-overrides: Updated.

 -- Boyuan Yang <byang@debian.org>  Sun, 11 Dec 2022 15:56:57 -0500

marisa (0.2.6-11) unstable; urgency=medium

  * Team upload
  * debian/libmarisa0.symbols:
    - Update other archs for LTO using buildd logs (closes: #1015539)

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Sat, 23 Jul 2022 15:30:13 +0200

marisa (0.2.6-10) unstable; urgency=medium

  * Team upload
  * Start fixing FTBFS with LTO enabled (see bug 1015539):
    - debian/rules: Enable LTO
    - create symbols file for amd64 only
  * Bump Standards-Version to 4.6.1

 -- Gunnar Hjalmarsson <gunnarhj@debian.org>  Sat, 23 Jul 2022 01:16:20 +0200

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 #export DH_VERBOSE=1
 
 # see FEATURE AREAS in dpkg-buildflags(1)
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
 export DEB_LDFLAGS_MAINT_APPEND =
 
 # Retrieve package version information
@@ -85,3 +85,19 @@
 override_dh_gencontrol:
 	dh_gencontrol -- \
 	        -V"ruby:Build-Version=$$(dpkg-query -f='$${Version}' -W ruby)"
+
+# hack to allow one to build twice
+# see https://bugs.debian.org/1047554, https://bugs.debian.org/1049679
+execute_before_dh_autoreconf:
+	cp -pR bindings bindings.bak
+	cp -pR tests tests.bak
+
+execute_after_dh_clean:
+	if [ -e bindings.bak ]; then \
+		rm -rf bindings; \
+		mv bindings.bak bindings; \
+	fi
+	if [ -e tests.bak ]; then \
+		rm -rf tests; \
+		mv tests.bak tests; \
+	fi

## marisa 0.3.1+git20250817

=== debian/changelog ===
marisa (0.3.1+git20250817-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Thu, 25 Sep 2025 10:02:27 -0400

marisa (0.3.1+git20250817-1~exp2) experimental; urgency=medium

  * debian/patches/0005-tests-Fix-double-value-comparison-error-on-i386.patch:
    Fix test errors on i386.

 -- Boyuan Yang <byang@debian.org>  Tue, 23 Sep 2025 09:10:40 -0400

marisa (0.3.1+git20250817-1~exp1) experimental; urgency=medium

  * New upstream version 0.3.1+git20250817.
  * debian/control: Move package description to source package section.
  * debian/rules: Migrate to bindings/python3 and cmake.
  * debian/patches: Rework on all patches:
    - 0002-0005-Fix-wordsize-*.patch: Dropped, upstream has migrated away from
      autotools.
    + 0002-Do-not-build-legacy-python2-bindings.patch: Added.
    + 0001-Specify-python-module-version-for-litian4py-warning.patch: Updated.
    + 0003-CMakeLists.txt-Enforce-global-PIC.patch: Globally enable
      CMAKE_POSITION_INDEPENDENT_CODE flag.

 -- Boyuan Yang <byang@debian.org>  Tue, 16 Sep 2025 17:13:28 -0400

marisa (0.2.6-19) unstable; urgency=medium

  * debian/control: Add build-dependency to perl-xs-dev.
    (Closes: #1102831)

 -- Boyuan Yang <byang@debian.org>  Sat, 12 Apr 2025 20:15:58 -0400

marisa (0.2.6-18) unstable; urgency=medium

  * debian/control: Add missing build-dependency python3-setuptools.
    (Closes: #1080673)
  * debian/control: Use build-dependency dh-sequence-pkgkde-symbolshelper.
  * debian/rules: Drop --with pkgkde-symbolshelper accordingly.

 -- Boyuan Yang <byang@debian.org>  Thu, 05 Sep 2024 17:22:59 -0400

=== debian/control ===
Source: marisa
Section: libs
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
 Mitsuya Shibata <mty.shibata@gmail.com>,
Build-Depends:
 chrpath,
 cmake (>= 3.22),
 debhelper-compat (= 13),
 dh-sequence-pkgkde-symbolshelper,
 dh-sequence-python3,
 perl,
 perl-xs-dev,
 python3-all-dev,
 python3-setuptools,
 ruby,
 ruby-dev,
 swig,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/s-yata/marisa-trie
Vcs-Browser: https://salsa.debian.org/input-method-team/marisa
Vcs-Git: https://salsa.debian.org/input-method-team/marisa.git
Description: MARISA algorithm implementation library
 Matching Algorithm with Recursively Implemented StorAge (MARISA) is a static
 and space-efficient trie data structure.

Package: libmarisa-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libmarisa1 (= ${binary:Version}),
 ${misc:Depends},
Description: development files for libmarisa
 ${source:Extended-Description}
 .
 This package contains the files necessary for compiling programs that
 depend on MARISA.

Package: libmarisa-perl
Section: perl
Architecture: any
Multi-Arch: foreign
Depends:
 libmarisa1 (= ${binary:Version}),
 ${misc:Depends},
 ${perl:Depends},
 ${shlibs:Depends},
Description: Perl bindings for MARISA
 ${source:Extended-Description}
 .
 This package contains Perl bindings for MARISA.

Package: libmarisa1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: C++ library to provide an implementation of MARISA
 ${source:Extended-Description}
 .
 This package contains C++ library to provide an implementation of MARISA.

Package: marisa
Section: utils
Architecture: any
Depends:
 libmarisa1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: command line tools for libmarisa
 ${source:Extended-Description}
 .
 This package contains command line tools for libmarisa.

Package: python3-marisa
Section: python
Architecture: any
Depends:
 libmarisa1 (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python3 bindings for MARISA
 ${source:Extended-Description}
 .
 This package contains Python 3 bindings for MARISA.

Package: ruby-marisa
Section: ruby
Architecture: any
Multi-Arch: foreign
Depends:
 libmarisa1 (= ${binary:Version}),
 ruby (>= ${ruby:Build-Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Ruby bindings for MARISA
 ${source:Extended-Description}
 .
 This package contains Ruby bindings for MARISA.

=== debian/rules ===
--- 
+++ 
@@ -27,45 +27,46 @@
 
 
 %:
-	dh $@  --with pkgkde_symbolshelper
+	dh $@
 
+# We do not use bindings/python, see https://github.com/s-yata/marisa-trie/issues/55
+# -DCMAKE_BUILD_TYPE=Release is necessary to install shared libraries
 override_dh_auto_configure:
-	dh_auto_configure
+	dh_auto_configure -- \
+	        -DBUILD_SHARED_LIBS=ON \
+	        -DCMAKE_BUILD_TYPE=Release \
+	        $(NULL)
 	make -C bindings
-	cd bindings/python; sed -i "s/__version__/$(DEB_VERSION_UPSTREAM)/" setup.py
+	cd bindings/python3; sed -i "s/__version__/$(DEB_VERSION_UPSTREAM)/" setup.py
 
-override_dh_auto_build:
-	dh_auto_build
+execute_after_dh_auto_build:
 	cd bindings/perl; perl Makefile.PL \
 	    INSTALL_BASE=$(CURDIR)/debian/libmarisa-perl/usr \
 	    INSTALLARCHLIB=$(CURDIR)/debian/libmarisa-perl$(PERL_VENDOR_ARCH) \
 	    INSTALLSITEARCH=$(CURDIR)/debian/libmarisa-perl$(PERL_VENDOR_ARCH) \
 	    INSTALLVENDORARCH=$(CURDIR)/debian/libmarisa-perl$(PERL_VENDOR_ARCH) \
 	    INC="-I../../include" \
-	    LIBS="-L../../lib/marisa/.libs -lmarisa" \
+	    LIBS="-L../../obj-$(DEB_HOST_GNU_TYPE) -lmarisa" \
 	    CCFLAGS="$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)" \
 	    LDDLFLAGS="-shared -L/usr/local/lib -fstack-protector $(shell dpkg-buildflags --get LDFLAGS)"
 	# Build for each Python 3 version
-	cd bindings/python; \
+	cd bindings/python3; \
 	    set -ex; for python in $(PYTHON3); do \
 	    $$python setup.py build_ext --include-dirs=../../include \
-	        --library-dirs=../../lib/marisa/.libs; \
+	        --library-dirs=../../obj-$(DEB_HOST_GNU_TYPE); \
 	    done
 	cd bindings/perl; make
 	# extconf.rb needs to exist library when configure
 	cd bindings/ruby; ruby extconf.rb --with-opt-include=../../include \
-	    --with-opt-lib=../../lib/marisa/.libs
+	    --with-opt-lib=../../obj-$(DEB_HOST_GNU_TYPE)
 	# set verbose option for compiling
 	sed -i 's/^V = 0/V = 1/' bindings/ruby/Makefile
 	sed -i 's%^sitearchdir = .*%sitearchdir = $$(exec_prefix)/lib/$(DEB_HOST_MULTIARCH)/ruby/$$(ruby_version)%' bindings/ruby/Makefile
 	cd bindings/ruby; make
 
-override_dh_auto_install:
-	dh_auto_install
-	# Remove .la files
-	rm debian/tmp/usr/lib/*/libmarisa.la
+execute_after_dh_auto_install:
 	# The same for install; note the --install-layout=deb option
-	cd bindings/python; \
+	cd bindings/python3; \
 	    set -ex; for python in $(PYTHON3); do \
 	    $$python setup.py install \
 	        --root=$(CURDIR)/debian/python3-marisa --install-layout=deb; \

=== debian/tests/control ===
--- 
+++ 
@@ -1,8 +1,5 @@
 Tests: python3
 Depends: python3-marisa
-
-Tests: python2
-Depends: python-marisa
 
 Tests: perl
 Depends: libmarisa-perl

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%marisa-$1.tar.gz%" \
 https://github.com/s-yata/marisa-trie/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
